﻿  ; Load Hyphenation
  ;
  ; V1.0 - 15/JUN/2013
  ;        o Just placed a warning window saying it is not coded yet.
  ; V1.1 - 1/DEC/2017
  ;        o Message Requesters now have a sign.  
  ; V1.2 - 28/MAR/2018
  ;        o Started coding the hyphenator.
  ;
  Procedure load_hyphenation(force_file$)
    
    StatusBarText(#WINDOW_MAIN_STATUS_BAR, 0, "Loading Hyphenation... <ESC> to abort.")
    StatusBarProgress(#WINDOW_MAIN_STATUS_BAR,1,0,#PB_StatusBar_Raised)
    
    ; Confirm if to load a new Hyphenation if the file in memory has been changed
    If hyphenation_changed=#True
      If MessageRequester("Warning!","The Hyphenation has been changed."+#LF$+#LF$+"Continue?",#PB_MessageRequester_YesNo|#PB_MessageRequester_Info)=#PB_MessageRequester_No : ProcedureReturn #False : EndIf
    EndIf    
    
    
    If force_file$=""
      file$=OpenFileRequester("Open Hyphenation", "", "Hyphenation (*.dic)|*.dic", 0)
      If file$=""
        StatusBarText(#WINDOW_MAIN_STATUS_BAR, 0, "Aborted.")  
        ProcedureReturn #False
      EndIf
    Else
      file$=force_file$
    EndIf      
    
    
    ; Check if .DIC file exists
    If FileSize(file$)<=0
      MessageRequester("Error", ".DIC file not found.",#PB_MessageRequester_Warning)
      StatusBarText(#WINDOW_MAIN_STATUS_BAR, 0, "File not found.")
      ProcedureReturn #False
    EndIf    
    
  
    ; Check If .DIC is in UTF-8 format
    ReadFile(1,file$)
      text$=UCase(ReadString(1,#PB_UTF8))
    CloseFile(1)
    If text$<>"UTF-8"
      If MessageRequester("Warning!","Hyphenation is not in "+Chr(34)+"UTF-8 WITHOUT BOM"+Chr(34)+" format:"+#LF$+text$+#LF$+#LF$+"It may lead to corrupt results."+#LF$+"Continue?",#PB_MessageRequester_YesNo|#PB_MessageRequester_Warning)=#PB_MessageRequester_No
        StatusBarText(#WINDOW_MAIN_STATUS_BAR, 0, "Aborted.")
        ProcedureReturn #False
      EndIf
    EndIf    
    
    
    hyphenation_changed=#False ; Hyphenation set to unchanged
    ; Load .DIC file
    SetGadgetText(#EDITORGADGET_PANEL_HYPHENATOR_DIC,"") ; Clear the .DIC text gadget   
    FUCKTIME = ElapsedMilliseconds()    
    ReadFile(1,file$)
      buffer$=ReadString(1,#PB_UTF8|#PB_File_IgnoreEOL)    
    CloseFile(1)
    buffer$=convert_to_linux(buffer$)
    SetGadgetText(#EDITORGADGET_PANEL_HYPHENATOR_DIC,buffer$)
             
    
    Debug "Time taken:"+Str((ElapsedMilliseconds()-FUCKTIME)/1000)
    RemoveWindowTimer(#WINDOW_MAIN,800)
    hyphenation_words_filename$=file$
    update_filename_hyphenation()
    StatusBarProgress(#WINDOW_MAIN_STATUS_BAR,1,0,#PB_StatusBar_Raised) ; Reset progress bar - 21/MAR/2014

    
    ; 31/OCT/2017 - Support for "Recent Files" menu entry
    create_load_update_recent_files(file$)
    update_recent_files_menu()
    
    StatusBarText(#WINDOW_MAIN_STATUS_BAR, 0, "Okay.")

  EndProcedure 
  
  
  
  
  ; Save/Save As Hyphenation
  ;
  ; V1.0 - 15/JUN/2013
  ;        o Just placed a warning window saying it is not coded yet.
  ; V1.1 - 1/DEC/2017
  ;        o Message Requesters now have a sign.     
  ; V1.2 - Saves Hyphenation .DIC
  ;
  Procedure save_saveas_hyphenation(save, saveas)
    
    StatusBarText(#WINDOW_MAIN_STATUS_BAR, 0, "Saving Hyphenation... <ESC> to abort.")
    StatusBarProgress(#WINDOW_MAIN_STATUS_BAR,1,0,#PB_StatusBar_Raised) 

    
    t$=GetGadgetText(#EDITORGADGET_PANEL_HYPHENATOR_DIC)
    If t$=""
      MessageRequester("Warning!","The .DIC file is empty.",#PB_MessageRequester_Warning)
      StatusBarText(#WINDOW_MAIN_STATUS_BAR, 0, "Aborted.") 
      ProcedureReturn #False
    EndIf    
    
    If save=1 : file$=hyphenation_words_filename$ : EndIf
    
    If save=1 And hyphenation_words_filename$="" : saveas=1 : EndIf
    
    If saveas=1
      file$=SaveFileRequester("Save Hyphenation", "", "Hyphenation Dictionary (*.dic)|*.dic", 0)
      If file$=""
        StatusBarText(#WINDOW_MAIN_STATUS_BAR, 0, "Aborted.") 
        ProcedureReturn #False
      EndIf
      If LCase(Right(file$,4))<>".dic" : file$+".dic": EndIf
    EndIf
    

    If FileSize(file$)>0 And saveas=1
      If MessageRequester("Warning!","File already exists! Overwrite it?",#PB_MessageRequester_YesNo|#PB_MessageRequester_Warning)=#PB_MessageRequester_No
        StatusBarText(#WINDOW_MAIN_STATUS_BAR, 0, "Aborted.") 
        ProcedureReturn #False
      EndIf      
    EndIf    
    
    DeleteFile(file$) ; Delete .DIC file    
    
    ; Save the .DIC file, using UTF-8 encoding
    t$=convert_to_linux(GetGadgetText(#EDITORGADGET_PANEL_HYPHENATOR_DIC))
    OpenFile(1,file$)
      WriteString(1,t$,#PB_UTF8)
    CloseFile(1)
              

    Debug "Time taken:"+Str((ElapsedMilliseconds()-FUCKTIME)/1000)
    RemoveWindowTimer(#WINDOW_MAIN,800)      
    StatusBarProgress(#WINDOW_MAIN_STATUS_BAR,1,f,#PB_StatusBar_Raised)
      
    ; Dictionary set to unchanged
    hyphenation_changed=#False
    update_number_hyphenations()
    
    ; 31/OCT/2017 - Support for "Recent Files" menu entry
    create_load_update_recent_files(file$)
    update_recent_files_menu()      
      
    hyphenation_words_filename$=file$
    update_filename_hyphenation()
    StatusBarProgress(#WINDOW_MAIN_STATUS_BAR,1,0,#PB_StatusBar_Raised) ; Reset progress bar - 27/MAR/2014
    StatusBarText(#WINDOW_MAIN_STATUS_BAR, 0, "Okay.")
    
  EndProcedure   
  
  
  
  
  ; Updates the filename of the words in the Hyphenation
  ; Used in open and save as
  ;
  ; V1.0 - 28/MAR/2018
  ;
  Procedure update_filename_hyphenation()
    
    a$=""
    If Len(hyphenation_words_filename$)>0
      t=CountString(hyphenation_words_filename$,"/")
      If t>0 : a$=StringField(hyphenation_words_filename$,t+1,"/") : EndIf
      t=CountString(hyphenation_words_filename$,"\")
      If t>0 : a$=StringField(hyphenation_words_filename$,t+1,"\") : EndIf
    EndIf      
    If a$="" : a$="n/a" : EndIf
    SetGadgetText(#TEXT_PANEL_PANEL_HYPHENATOR_FILENAME,"Filename:"+a$)
    
  EndProcedure  
  
 
  
  ; To update the vertical scroll bar of the hypheantion and refresh the items in the listicongadget
  ; V1.0 - 28/MAR/2018
  ;
  Procedure update_vertical_scroll_bar_hyphenation()  
    ClearGadgetItems(#LISTICONGADGET_PANEL_HYPHENATOR)
    If number_of_words=0
      SetGadgetAttribute(#LISTICONGADGET_PANEL_HYPHENATOR_VERTICAL_BAR,#PB_ScrollBar_Minimum,0)
      SetGadgetAttribute(#LISTICONGADGET_PANEL_HYPHENATOR_VERTICAL_BAR,#PB_ScrollBar_Maximum,0)
      ProcedureReturn
    EndIf
    beginloop = GetGadgetState(#LISTICONGADGET_PANEL_HYPHENATOR_VERTICAL_BAR)
;     endloop = beginloop + 10
    endloop=beginloop+number_of_lines-1
    If endloop>ArraySize(words$())
      endloop=ArraySize(words$())
    EndIf
    For f=beginloop To endloop      
      AddGadgetItem(#LISTICONGADGET_PANEL_HYPHENATOR,-1,Str(f+1)+#LF$+words$(f))      
      SetGadgetItemColor(#LISTICONGADGET_PANEL_HYPHENATOR,#PB_All,#PB_Gadget_FrontColor,$999999,0)
      If words_selected(f)=#True : SetGadgetItemState(#LISTICONGADGET_PANEL_HYPHENATOR,f-beginloop,#PB_ListIcon_Checked) : EndIf
    Next f
    
    t=beginloop
    t1=selected_hyphenation_word-t
;     If t1>=0 And t1<=10 : SetGadgetState(#LISTICONGADGET_PANEL_HYPHENATOR,t1) : EndIf           
    If t1>=0 And t1<=number_of_lines-1 : SetGadgetState(#LISTICONGADGET_PANEL_HYPHENATOR,t1) : EndIf           
    
  EndProcedure
  
  
  
  
  ; To always have the current word highlighted in the listicongadget
  ;
  ; V1.0 - 28/MAR/2018
  ;
  Procedure update_vertical_scroll_bar_hyphenation_current_item()  
    If selected_hyphenation_word=-1 And GetGadgetState(#LISTICONGADGET_PANEL_HYPHENATOR)=-1 : ProcedureReturn #False : EndIf
  
    selected_hyphenation_word=GetGadgetState(#LISTICONGADGET_PANEL_HYPHENATOR)+GetGadgetState(#LISTICONGADGET_PANEL_HYPHENATOR_VERTICAL_BAR)   
    t=GetGadgetState(#LISTICONGADGET_PANEL_HYPHENATOR_VERTICAL_BAR)
    t1=selected_hyphenation_word-t
    
  EndProcedure
  
  
  
  
  ; Updates the number of items in the Hyphenation
  ;
  ; V1.0 - 28/MAR/2018
  ; V1.1 - 20/JUL/2018
  ;        o Now the changes allow a colour asterisk in red 
  ; V1.2 - 23/JUL/2018
  ;        o Fix: Asterisks in red no longer flash
  ; V1.3 - 27/JUL/2018
  ;        28/JUL/2018
  ;        o Fix: Reduced asterisks vanishing if scrolling holding down the arrow keys
  ; V1.4 - 19/SEP/2018
  ;        o Floppy icon on tabs (blue/red)
  ;
  Procedure update_number_hyphenations()
    
    ; Black/Red floppy
    If hyphenation_changed=#False And GetGadgetText(#TEXT_PANEL_PANEL_HYPHENATOR_NUMBER_WORDS_ASTERISK)<>""
      SetGadgetItemImage(#PANEL_MAIN,2,ImageID(71))
    EndIf
    If hyphenation_changed=#True And GetGadgetText(#TEXT_PANEL_PANEL_HYPHENATOR_NUMBER_WORDS_ASTERISK)<>"*"
      SetGadgetItemImage(#PANEL_MAIN,2,ImageID(72))
    EndIf  
    
    t$=""
    If hyphenation_changed=#True : t$="*" : EndIf        
    If selected_hyphenation_word=-1
      t1$="# Words:"+FormatNumber(number_of_words,0,".",number_separator_chr$)
    Else
      t1$="Word: ["+FormatNumber(selected_hyphenation_word+1,0,".",number_separator_chr$)+"/"+FormatNumber(number_of_words,0,".",number_separator_chr$)+"]"
    EndIf
    
    If t1$<>GetGadgetText(#TEXT_PANEL_PANEL_HYPHENATOR_NUMBER_WORDS)
      gadget=#TEXT_PANEL_PANEL_HYPHENATOR_NUMBER_WORDS
      gadget2=#TEXT_PANEL_PANEL_HYPHENATOR_NUMBER_WORDS_ASTERISK
      w=GadgetWidth(gadget)
      SetGadgetText(gadget,t1$)
      GadgetFit(gadget)
      If GadgetX(gadget2)<GadgetX(gadget)+GadgetWidth(gadget) Or GadgetX(gadget2)>=GadgetX(gadget)+GadgetWidth(gadget)+4
        ResizeGadget(gadget2,GadgetX(gadget)+GadgetWidth(gadget),GadgetY(gadget),16,16)                        
        GadgetRefresh(gadget2)  
      EndIf
    EndIf    
    
    If GetGadgetText(#TEXT_PANEL_PANEL_HYPHENATOR_NUMBER_WORDS_ASTERISK)<>t$
      SetGadgetText(#TEXT_PANEL_PANEL_HYPHENATOR_NUMBER_WORDS_ASTERISK,t$)
    EndIf
       
  EndProcedure    
  
  
  
  
  ; Updates the number of items in the Hyphenation ListIconGadget
  ;
  ; V1.0 - 22/APR/2018
  ;
  Procedure update_number_words_for_hyphenation()
    
    t$="# Hyphenations:"+Str(CountGadgetItems(#LISTICONGADGET_PANEL_HYPHENATOR_DIC))
    If GetGadgetText(#TEXT_PANEL_PANEL_HYPHENATOR_NUMBER_WORDS_TO_BE_HYPHENATED)<>t$
      SetGadgetText(#TEXT_PANEL_PANEL_HYPHENATOR_NUMBER_WORDS_TO_BE_HYPHENATED,t$)
    EndIf
    
  EndProcedure    
  
  
  
  
  ; To hyphenate the word in the StringGadget
  ;
  ; V1.0 - 1/APR/2018
  ;        2/APR/2018
  ;        4/APR/2018
  ; V1.1 - 13/APR/2018
  ;        o Support for compressed AF
  ; V1.2 - 19/APR/2018
  ;        o Hyphenation only works if the EditorGadget starts with the word "UTF-8".
  ; V1.3 - 22/APR/2018
  ;        o Support label: "# Hyphenations:"
  ; V1.4 - 17/MAY/2018
  ;        o Improved error handling in hyphenator.  
  ;
  Procedure hyphenate_word()
    
    If GetGadgetText(#STRING_PANEL_HYPHENATOR_WORD)=""
      MessageRequester("Warning!","No word selected.",#PB_MessageRequester_Warning)
      ProcedureReturn #False
    EndIf

    
    FUCKTIME = ElapsedMilliseconds()
    
    ClearGadgetItems(#LISTICONGADGET_PANEL_HYPHENATOR_DIC)
    
    ; To create a faster searchable version of the AFF gadgettext with just single spaces
    faster_searchable_version_of_aff()
    
    process_pfx_sfx(1,GetGadgetText(#STRING_PANEL_HYPHENATOR_WORD),#False,#False,#False,"","","",#True,#False)
    
    update_number_words_for_hyphenation()
    
    last_hyphenated_word$=GetGadgetText(#STRING_PANEL_HYPHENATOR_WORD)
    
    If faster_searchable_version_of_hyphenation_dic()=#False : ProcedureReturn : EndIf
    
    parse_rules_against_words_to_be_hyphenated()
    
    Debug "Time taken:"+Str((ElapsedMilliseconds()-FUCKTIME)/1000)
    
  EndProcedure
  
  
  
  
  ; Last Hyphenated word update
  ;
  ; V1.0 - 2/APR/2018
  ;        4/APR/2018
  ; V1.1 - 13/APR/2018
  ;        o Support for compressed AF
  ; V1.2 - 19/APR/2018
  ;        o Hyphenation only works if the EditorGadget starts with the word "UTF-8".
  ; V1.3 - 22/APR/2018
  ;        o Support label: "# Hyphenations:"
  ; V1.4 - 17/MAY/2018
  ;        o Improved error handling in hyphenator.  
  ;
  Procedure hyphenate_update()
    
    
    If last_hyphenated_word$=""
      MessageRequester("Warning!","No last hyphenated word.",#PB_MessageRequester_Warning)
      ProcedureReturn #False
    EndIf
    
    
    FUCKTIME = ElapsedMilliseconds()
    
    ClearGadgetItems(#LISTICONGADGET_PANEL_HYPHENATOR_DIC)
    
    ; To create a faster searchable version of the AFF gadgettext with just single spaces
    faster_searchable_version_of_aff()
     
    process_pfx_sfx(1,last_hyphenated_word$,#False,#False,#False,"","","",#True,#False)
    
    update_number_words_for_hyphenation()
    
    If faster_searchable_version_of_hyphenation_dic()=#False : ProcedureReturn : EndIf

    parse_rules_against_words_to_be_hyphenated()
    
    Debug "Time taken:"+Str((ElapsedMilliseconds()-FUCKTIME)/1000)
    
  EndProcedure
  
  
  
  
  ; To create a quick search version of the hyphenation .dic
  ;
  ; It adds to a string the rules with spaces between words and without numbers: ultrafast_hyphenation_rules$
  ; The numbers are later checked in the string: last_hyphenation_rules$
  ;
  ; V1.0 - 4/APR/2018
  ;        6/APR/2018
  ; V1.1 - 19/APR/2018
  ;        o Fix: Didn't skip the word "UTF-8"
  ;        o Fix: defaults MIN LEFT/RIGHT before checking for new values
  ;        o Now it detects if rules don't end with a <RETURN>
  ; V1.3 - 25/APR/2018
  ;        o Support for "-" in hyphenation rules  
  ;        o Support for "%" in hyphenation rules  
  ; V1.4 - 26/APR/2018
  ;        o Major Speed up of hyphenation
  ; V1.5 - 17/MAY/2018
  ;        o Improved error handling in hyphenator.
  ;
  Procedure faster_searchable_version_of_hyphenation_dic()
    
    Debug "Inside the Faster Decoding of the Hyphenation rules!"
    
    ; Get the EditorGadget text that has the rules
    t$=GetGadgetText(#EDITORGADGET_PANEL_HYPHENATOR_DIC)
    t$=convert_to_linux(t$)
    t1$=t$ ; Because the validity tests below will change the t$ from the previous line
    
    
    ; Check if there were no changes in the rules after the previous parsing optimisation
    If last_hyphenation_rules$=t$ And t$<>""
      ProcedureReturn #True
    EndIf    
    
    
    ; Check if "UTF-8" string exists at beginning of rules
    If FindString(t$,"UTF-8")<>1
      MessageRequester("Warning!","Hyphenation rules must start with "+Chr(34)+"UTF-8"+Chr(34)+".",#PB_MessageRequester_Warning)
      ProcedureReturn #False
    EndIf
    
    
    ; Check if no #LF$ at the end of rules
    If Right(t$,1)<>#LF$
      MessageRequester("Warning!","Rules must end with an #LF$ (RETURN)",#PB_MessageRequester_Warning)      
      ProcedureReturn #False
    EndIf
     
    
    ; Check if it really has rules and not just the five-line header
    If CountString(t$,#LF$)<=1
      MessageRequester("Warning!","No Rules to parse.",#PB_MessageRequester_Warning)      
      ProcedureReturn #False
    EndIf    
    
    
    ; Check if no rules
    t$=ReplaceString(t$," ","")
    t$=ReplaceString(t$,#LF$,"")
    If t$="UTF-8"
      MessageRequester("Warning!","No Rules to parse.",#PB_MessageRequester_Warning)      
      ProcedureReturn #False 
    EndIf
    
    
    ; New rules added
    last_hyphenation_rules$=t1$    
     
    
    ; Count number of fields separated with #LF$ in the Editor Gadget
    number_of_LFs=CountString(last_hyphenation_rules$,#LF$)    
    
    
    ; Copy the rules to ultrafast string
    Dim rules_of_hyphenations$(number_of_LFs) ; without numbers
    Dim rules_of_hyphenations_with_numbers$(number_of_LFs) ; with numbers
    
        
    ; Defaults MIN LEFT/RIGHT before checking for new values
    hyphenation_LEFTHYPHENMIN=1
    hyphenation_RIGHTHYPHENMIN=1
    hyphenation_COMPOUNDLEFTHYPHENMIN=1
    hyphenation_COMPOUNDRIGHTHYPHENMIN=1    
    
    
    count=0 ; # of rules, incremented if valid rule to avoid headers appearing in the array (f)

    StatusBarText(#WINDOW_MAIN_STATUS_BAR, 0, "Optimising Hyphenation decode cache...")    
    
    ; Show the progress bar
    StatusBarProgress(#WINDOW_MAIN_STATUS_BAR,1,0,#PB_StatusBar_Raised,0,number_of_LFs)     
    
    AddWindowTimer(#WINDOW_MAIN,800,800) 
    For f=1 To number_of_LFs
      
      rule_old$=StringField(last_hyphenation_rules$,f,#LF$)
      
      ; Check if MIN LEFT/RIGHT + UTF-8
      flag=#False
      If Left(rule_old$,13)="LEFTHYPHENMIN"      
        hyphenation_LEFTHYPHENMIN=Val(StringField(rule_old$,2," "))
        flag=#True
      EndIf
      If Left(rule_old$,14)="RIGHTHYPHENMIN"
        hyphenation_RIGHTHYPHENMIN=Val(StringField(rule_old$,2," "))
        flag=#True
      EndIf
      If Left(rule_old$,21)="COMPOUNDLEFTHYPHENMIN"
        hyphenation_COMPOUNDLEFTHYPHENMIN=Val(StringField(rule_old$,2," "))
        flag=#True
      EndIf
      If Left(rule_old$,22)="COMPOUNDRIGHTHYPHENMIN"
        hyphenation_COMPOUNDRIGHTHYPHENMIN=Val(StringField(rule_old$,2," "))
        flag=#True
      EndIf            
      ; Skip "UTF-8"
      If Left(rule_old$,5)="UTF-8"      
        flag=#True
      EndIf
      ; Skip "%"
      If Left(rule_old$,1)="%"      
        flag=#True
      EndIf      
      
      
      
     If flag=#False 
       
      count+1
       
      rule_new$=""
      rule_new_with_numbers$=""
      For ff=1 To Len(rule_old$)
        
        t$=Mid(rule_old$,ff,1)
        If (Val(t$)>=1 And Val(t$)<=9) Or t$="-"
          
          ; In case the rules starts with a number
          If ff=1
            rule_new$=" "
            rule_new_with_numbers$=" "
          EndIf
            
;           Debug "rule_new_with_numbers$:|"+rule_new_with_numbers$+"|"
          rule_new$=InsertString(rule_new$," ",Len(rule_new$))
          rule_new$=Left(rule_new$,Len(rule_new$)-1)
          rule_new_with_numbers$=InsertString(rule_new_with_numbers$,t$,Len(rule_new_with_numbers$))          
          rule_new_with_numbers$=Left(rule_new_with_numbers$,Len(rule_new_with_numbers$)-1)
        Else
          rule_new$+t$+" "
          rule_new_with_numbers$+t$+" "
        EndIf
        
     
      Next ff   
      
      If Right(rule_new$,1)=" ": rule_new$=Left(rule_new$,Len(rule_new$)-1) : EndIf
      If Right(rule_new_with_numbers$,1)=" ": rule_new_with_numbers$=Left(rule_new_with_numbers$,Len(rule_new_with_numbers$)-1) : EndIf
      
      rules_of_hyphenations$(count)=rule_new$
      rules_of_hyphenations_with_numbers$(count)=rule_new_with_numbers$

      
     EndIf       
      
      ; Fix to window stop responding if we click on it while adding synonyms, plus update the progress bar
      event=WindowEvent()
      If event=#PB_Event_Timer And EventTimer()=800
        StatusBarProgress(#WINDOW_MAIN_STATUS_BAR,1,f,#PB_StatusBar_Raised)
      EndIf       
      

    Next f
    
    ; To adjust removing the headers and rems
    ReDim rules_of_hyphenations$(count) ; without numbers
    ReDim rules_of_hyphenations_with_numbers$(count) ; with numbers
    
    
    StatusBarText(#WINDOW_MAIN_STATUS_BAR, 0, "Okay.")
 
    RemoveWindowTimer(#WINDOW_MAIN,800)
    StatusBarProgress(#WINDOW_MAIN_STATUS_BAR,1,0,#PB_StatusBar_Raised) ; Reset progress bar - 21/MAR/2014      
    
    ProcedureReturn #True
    
  EndProcedure
  
  
  
  
  ; The checking of rules against each word
  ;
  ; V1.0 - 4/APR/2018
  ;        5/APR/2018
  ;        6/APR/2018
  ; V1.1 - 18/APR/2018
  ;        o While hyphenating words it shows the current count+total
  ; V1.2 - 19/APR/2018
  ;        o Fix: Parsing of rules would skip the 5 lines header (if no standard header, it would skip the first 5 five rules)
  ;        o Better detection of no rules
  ; V1.3 - 23/APR/2018
  ;        o Hyphenation now respects the flags: LEFTHYPHENMIN and RIGHTHYPHENMIN.
  ; V1.4 - 25/APR/2018
  ;        o Fix: Hyphenation now supports repeated rules per word
  ;        o Support for "-" in hyphenation rules
  ; V1.5 - 26/APR/2018
  ;        o Major Speed up of hyphenation
  ; V1.6 - 2/MAY/2018
  ;        o Hyphenation: Fixed/Improved the display of rules:
  ;           1) No spaces
  ;           2) dots
  ; V1.7 - 17/MAY/2018
  ;        o Improved error handling in hyphenator.  
  ;  
  Procedure parse_rules_against_words_to_be_hyphenated()
    
    Debug "Inside the RULES against WORD"    
 
    ; Number of fields separated with #LF$
    number_of_LFs=ArraySize(rules_of_hyphenations$())

    
    ; Number of words to hyphenate in the ListIconGadget
    number_of_words_to_hyphenate=CountGadgetItems(#LISTICONGADGET_PANEL_HYPHENATOR_DIC)
    

    
    ; Show the progress bar
    StatusBarProgress(#WINDOW_MAIN_STATUS_BAR,1,0,#PB_StatusBar_Raised,0,number_of_words_to_hyphenate*number_of_LFs)     
    
    progress_bar_value=0
    
    AddWindowTimer(#WINDOW_MAIN,800,800) 
    For current_word_to_hyphenate=0 To number_of_words_to_hyphenate-1
      
      StatusBarText(#WINDOW_MAIN_STATUS_BAR, 0, "Parsing rules against words:"+Str(current_word_to_hyphenate+1)+"/"+Str(number_of_words_to_hyphenate)+"... <ESC> To abort.")      
      
      hyphenation_keep_dot_left=#False ; To show dots in rules, #False or #True
      hyphenation_keep_dot_right=#False ; To show dots in rules, #False or #True
      
      word_to_hyphenate$="."+GetGadgetItemText(#LISTICONGADGET_PANEL_HYPHENATOR_DIC,current_word_to_hyphenate,0)+"."
      t$=""
      For ff=1 To Len(word_to_hyphenate$)
        t$+Mid(word_to_hyphenate$,ff,1)+" "
      Next ff
;       t$=Left(t$,Len(t$)-1)
      word_to_hyphenate$=t$
      word_to_hyphenate_with_numbers$=t$
      
Debug "word_to_hyphenate$:"+"|"+word_to_hyphenate$+"|"
Debug "word_to_hyphenate_with_numbers$:"+"|"+word_to_hyphenate_with_numbers$+"|"
             

      For f=1 To number_of_LFs
        
        rule_new$=rules_of_hyphenations$(f)
        rule_new_with_numbers$=rules_of_hyphenations_with_numbers$(f)
        
Debug "rule_new$:"+"|"+rule_new$+"|"
Debug "rule_new_with_numbers$:"+"|"+rule_new_with_numbers$+"|"
        
        ; Add/increase numbers in words being hyphenated
        counter=CountString(LCase(word_to_hyphenate$),LCase(rule_new$))
Debug "counter:"+Str(counter)
        If counter>0
          
          position=1
          
          For f_counter=1 To counter            
Debug "position:"+Str(position)            
            t=FindString(LCase(word_to_hyphenate$),LCase(rule_new$),position)
Debug "t:"+Str(t)
            If t>0
              position=t+1
              
              ; Check if keep left dot
              If hyphenation_keep_dot_left=#False
                If Left(rule_new$,1)="." : hyphenation_keep_dot_left=#True : EndIf
              EndIf
              
              ; Check if keep right dot
              If hyphenation_keep_dot_right=#False
                If Right(rule_new$,1)="." : hyphenation_keep_dot_right=#True : EndIf
              EndIf
                            
              For ff=1 To Len(rule_new_with_numbers$)
Debug "ff:"+Str(ff)+" Chr(ff):"+Mid(rule_new_with_numbers$,ff,1)            
                t$=Mid(rule_new_with_numbers$,ff,1) 
                If (Val(t$)>=1 And Val(t$)<=9) Or t$="-"
                  t1$=Mid(word_to_hyphenate_with_numbers$,ff+t-1,1)         
                  number_to_insert$=t1$
;               Debug "T$:"+t$+" T1$:"+t1$
                  If Val(t$)>Val(t1$) And t1$<>#LF$: number_to_insert$=t$ : EndIf                
                  If t$="-" : number_to_insert$=#LF$ : EndIf
                  word_to_hyphenate_with_numbers_process$=Left(word_to_hyphenate_with_numbers$,ff+t-1-1)+number_to_insert$+Mid(word_to_hyphenate_with_numbers$,ff+t)
                  word_to_hyphenate_with_numbers$=word_to_hyphenate_with_numbers_process$
                  Debug "word_to_hyphenate_with_numbers$ |||FUCK|||:"+word_to_hyphenate_with_numbers$
                EndIf
            
              Next ff
            EndIf
            
          Next f_counter
       EndIf
        
      
        ; Fix to window stop responding if we click on it while adding synonyms, plus update the progress bar
        event=WindowEvent()
        If event=#PB_Event_Timer And EventTimer()=800
          StatusBarProgress(#WINDOW_MAIN_STATUS_BAR,1,progress_bar_value,#PB_StatusBar_Raised)
;           StatusBarProgress(#WINDOW_MAIN_STATUS_BAR,1,(current_word_to_hyphenate+1)*f+f,#PB_StatusBar_Raised)
        EndIf       
        
        ; <ESC> pressed to abort
        If EventMenu()=1000
         If MessageRequester("Warning!","Really abort?",#PB_MessageRequester_YesNo|#PB_MessageRequester_Warning)=#PB_MessageRequester_Yes
            StatusBarText(#WINDOW_MAIN_STATUS_BAR, 0, "Aborted.")
            StatusBarProgress(#WINDOW_MAIN_STATUS_BAR,1,0,#PB_StatusBar_Raised)
            RemoveWindowTimer(#WINDOW_MAIN,800)           
            ProcedureReturn #False
         EndIf
        EndIf        
        
        progress_bar_value+1
        
        
      Next f
      
Debug "WORD HYPHENATED WITH NUMBERS:"+word_to_hyphenate_with_numbers$      

      ; Remove the artificial sides of the word
      word_to_hyphenate_with_numbers$=Mid(word_to_hyphenate_with_numbers$,3,Len(word_to_hyphenate_with_numbers$)-4)
      
      
Debug "WORD HYPHENATED WITH NUMBERS (SIDES REMOVED):"+word_to_hyphenate_with_numbers$            

      ; Place the word with numbers in the ListIconGadget
      t$=ReplaceString(word_to_hyphenate_with_numbers$,#LF$,"-")
      If hyphenation_keep_dot_left=#True :  t$=InsertString(t$,".",1) : EndIf ; To show dots in rules, #False or #True - 2/MAY/2018
      If hyphenation_keep_dot_right=#True : t$+"." : EndIf                ; To show dots in rules, #False or #True - 2/MAY/2018
      t$=ReplaceString(t$," ","") ; Now it removes the spaces in the rules - 2/MAY/2018
      SetGadgetItemText(#LISTICONGADGET_PANEL_HYPHENATOR_DIC,current_word_to_hyphenate,t$,2)
      
      ; Check the minimum hyphens left
      left_len=hyphenation_LEFTHYPHENMIN*2-2
      If Len(word_to_hyphenate_with_numbers$)<hyphenation_LEFTHYPHENMIN*2-2
        left_len=Len(word_to_hyphenate_with_numbers$)
      EndIf
      For ff=1 To left_len
        t$=Mid(word_to_hyphenate_with_numbers$,ff,1)
        If (Val(t$)>=1 And Val(t$)<=9) Or t$=#LF$ : word_to_hyphenate_with_numbers$=replace_chr_string(word_to_hyphenate_with_numbers$,"2",ff) : EndIf ; any number non-odd will do
      Next ff

      
      ; Check the minimum hyphens right
      right_len=hyphenation_RIGHTHYPHENMIN*2-2
      If Len(word_to_hyphenate_with_numbers$)<hyphenation_RIGHTHYPHENMIN*2-2
        right_len=Len(word_to_hyphenate_with_numbers$)
      EndIf
      For ff=Len(word_to_hyphenate_with_numbers$) To Len(word_to_hyphenate_with_numbers$)-right_len Step -1
        t$=Mid(word_to_hyphenate_with_numbers$,ff,1)
        If (Val(t$)>=1 And Val(t$)<=9) Or t$=#LF$ : word_to_hyphenate_with_numbers$=replace_chr_string(word_to_hyphenate_with_numbers$,"2",ff) : EndIf ; any number non-odd will do
      Next ff
      
      
;       ; Remove hyphen left
;       t$=Left(word_to_hyphenate_with_numbers$,1)
;       If t$="1" Or t$="3" Or t$="5" Or t$="7" Or t$="9"
;         word_to_hyphenate_with_numbers$="2"+Mid(word_to_hyphenate_with_numbers$,2) ; any non-odd number will do
;       EndIf
;       
;       ; Remove hyphen right
;       t$=Right(word_to_hyphenate_with_numbers$,1)
;       If t$="1" Or t$="3" Or t$="5" Or t$="7" Or t$="9"
;         word_to_hyphenate_with_numbers$=Left(word_to_hyphenate_with_numbers$,Len(word_to_hyphenate_with_numbers$)-1)+"2" ; any non-odd number will do
;       EndIf
      
      ; Replace #LF$ with "-"
      ReplaceString(word_to_hyphenate_with_numbers$,#LF$,"-",#PB_String_InPlace)
      
      ; Replace odd numbers with hyphens
      For ff=1 To 9 Step 2
        ReplaceString(word_to_hyphenate_with_numbers$,Str(ff),"-",#PB_String_InPlace)
      Next ff
      
      ; Remove all remaining numbers
      For ff=1 To 9
        word_to_hyphenate_with_numbers$=ReplaceString(word_to_hyphenate_with_numbers$,Str(ff),"")
      Next ff
      
      ; Remove spaces
      word_to_hyphenate_with_numbers$=ReplaceString(word_to_hyphenate_with_numbers$," ","")
      
      ; Place hyphenated word in the ListIconGadget
      SetGadgetItemText(#LISTICONGADGET_PANEL_HYPHENATOR_DIC,current_word_to_hyphenate,word_to_hyphenate_with_numbers$,0)
      
Debug "WORD HYPHENATED WITHOUT NUMBERS (FINAL):"+word_to_hyphenate_with_numbers$       


    Next current_word_to_hyphenate
    
    StatusBarText(#WINDOW_MAIN_STATUS_BAR, 0, "Okay.")

    RemoveWindowTimer(#WINDOW_MAIN,800)
    StatusBarProgress(#WINDOW_MAIN_STATUS_BAR,1,0,#PB_StatusBar_Raised) ; Reset progress bar - 21/MAR/2014      

    
  EndProcedure
  
  
  
  
  ; Clears the EditorGadget of the Hyphenation
  ;
  ; V1.0 - 21/APR/2018
  ; V1.1 - 22/APR/2018
  ;        o Support label: "# Hyphenations:"  
  ;
  Procedure clear_hyphenation()
    
    ; Confirm if to erase the Hyphenation if the file in memory has been changed
    If hyphenation_changed=#True
      If MessageRequester("Warning!","The Hyphenation has been changed."+#LF$+#LF$+"Continue?",#PB_MessageRequester_YesNo|#PB_MessageRequester_Info)=#PB_MessageRequester_No : ProcedureReturn #False : EndIf
    EndIf
    
    SetGadgetText(#EDITORGADGET_PANEL_HYPHENATOR_DIC,"UTF-8"+#LF$)
    
    ClearGadgetItems(#LISTICONGADGET_PANEL_HYPHENATOR_DIC)
    
    hyphenation_changed=#False
    
    update_number_words_for_hyphenation()
    
  EndProcedure
  
; IDE Options = PureBasic 5.62 (Windows - x64)
; CursorPosition = 233
; FirstLine = 229
; Folding = ---
; EnableXP
; CompileSourceDirectory
; EnableUnicode